//to chat: http://js.do/code/flexichat
http = require('http');
var history = [];
var messageId = 0;

var RPCFuncs = {
    getMessages: function(data){
        var messageId = +data.messageId;
        return history.slice(messageId);
    },
    addMessage:  function(data){
        history.push(data);
//        return history.length;
    }
};

server = http.createServer(function(req, res){
    if (req.method == "POST"){
        var body = '';
        req.on('data', function (data) {
                body += data;
        });
        req.on('end', function () {
                console.log("Body: " + body);
                data = JSON.parse(body);
                var timestamp =(new Date()).getTime(); 
                if ("func" in data){
                    if (data.func in RPCFuncs){
                        var func = data.func;
                        delete data.func;
                        data.timestamp = timestamp;
                        var result = {data: RPCFuncs[func](data), nextMessageId: history.length};
                        console.log("answer on request:");
                        console.log(JSON.stringify(result));
                        res.end(JSON.stringify(result));
                    }
                    else {
                        console.log("no func in functions array" + body);
                    }
                }
                else {
                    console.log("no func key in data:" + body);
                }

                //if (!("messageId" in message) || (Object.keys(message).length > 1)){
                    //message.timestamp  = timestamp;
                    //history[messageId] = message;
                    //messageId++;
                //}
                //if ("messageId" in message){
                    //messages = history.slice(+message.messageId);
                    //res.end(JSON.stringify({timestamp: timestamp, messageId: messageId, messages: messages}))
                    //console.log({timestamp: timestamp, messageId: messageId, messages: messages})
                //}
                //else {
                    //res.end(JSON.stringify({timestamp: timestamp, messageId: messageId}))
                    //console.log({timestamp: timestamp, messageId: messageId})
                //}
        });

        res.setHeader('Access-Control-Allow-Origin', '*');
        res.setHeader('Access-Control-Request-Method', '*');
        res.setHeader('Access-Control-Allow-Methods', 'OPTIONS, GET, POST');
        res.setHeader('Access-Control-Allow-Headers', '*');
        res.writeHead(200, {'Content-Type': 'text/json'});
        //res.end('post received');
    }
});

port = 8070;
host = '164.138.30.21';
server.listen(port, host);
console.log("Listen...");
